searchNodes=[{"doc":"Web API framework with a need for speed Use Maverick builds on top of the Plug.Conn.Adapter for your supported webserver and creates the webserver handler by reading annotations on functions you want to expose as part of your API. To publish a function, add use Maverick to your module and the @route attribute to the relevant functions. Pass a keyword list of options to the route attribute including the :path and you're off to the races. Once you add the Maverick.Api to your application supervision tree and start the app, Maverick compiles your routes into a handler module and sends incoming requests to your functions, taking care to wrap the return values accordingly. Example With Maverick added to your application's dependencies, create a module that implements the use Maverick.Api macro and pass it, at a minimum, the name of your application: defmodule CoolApp.Api do use Maverick.Api , otp_app : :cool_app end Then, in your application supervision tree, add your Maverick Api to the list of children: children = [ maybe_a_database , other_cool_stuff , { CoolApp.Api , name : :cool_app_web , port : 443 } , anything_else ] Now it's time to annotate the functions you want served over HTTP. These can be anywhere within your project structure that make sense to you, Maverick will compile them all into your callback handler. While it's considered best practice to structure your code to separate domain concerns and maintain good abstractions, in practice this organization has no effect on what functions are available to be routed to by Maverick. Add use Maverick to a module that will be serving functions and then any public function (sorry, no macros) with the @route annotation will do: defmodule CoolApp.BusinessLogics do use Maverick , scope : &quot;api/v1&quot; @route path : &quot;do/stuff&quot; def do_stuff ( %{ &quot;stuff&quot; =&gt; what_needs_doing } ) do what_needs_doing |&gt; transform_process_etc end end Once the app is started, you can reach your function at the path, method, etc. configured on the route annotation, such as: curl -XPOST -d '{\\&quot;stuff\\&quot;:\\&quot;transform-me!\\&quot;}' &quot;http://host:port/api/v1/do/stuff&quot; Route Options The following options can configure functions annotated with the @route attribute: :path - The path, as a string, at which the function should be accessible. Prefix elements of the path with a colon (&quot;:&quot;) if they should be treated as variables on requests, such as api/customers/:customer_id (required). :args - The format of the argument that will be passed to the internal function, which can be one of :params (the default), {:required_params: [atom()]} , or :request . :params - The argument passed to the function will be a string-keyed map merging the path parameters map, query parameters map, and the request body map. {:required_params, [atom()]} - The second element is a list of atoms representing keys that must appear and have non- nil values in the request params map, this subset of key/value pairs will be sent as a string-keyed map. :request - The entire Maverick request struct will be sent. This is good for handling requests that need access to deeper elements of the HTTP request like the source IP, scheme, port, manipulating headers, etc. :method - The HTTP method the function should respond to as an atom or a string. Defaults to &quot;POST&quot; (all methods are converted to uppercase strings so follow your personal tastes). :success_code - In the event of success, the HTTP status code that will be returned (defaults to 200). :error_code - In the event of an error (an explicit {:error, term()} ), the HTTP status code that will be returned. :scope - This special option is set at the module level ( use Maverick.Api, scope: &quot;path/prefix&quot; ), not on the @route attribute, to set a shared prefix for all routes handled within the module. Return Values Maverick aims to be simple to use, passing some form of map to your function (see :args in the above &quot;Route Options&quot; section) and taking virtually any JSON-encodable term as a result to return to the client. That said, the following are acceptable return values for your routed functions; use the simplest one that meets your needs and it will be converted accordingly to allow the webserver to hand it back to the client: response() - Any raw term will be assumed to be a successful request; must be encodable to JSON. {:ok, response()} - An explicit success; the term must be encodable to JSON. {:error, response()} - An explicit (non-exception) failure; the term must be encodable to JSON. {code(), headers(), response()} - A 3-tuple with an explicit integer status code, map of response headers, and response body which, you guessed it, must be encodable to JSON. In the absence of a full-detailed response return value, Maverick will apply the :success_code for the status code of {:ok, response()} and implicitly successful response() results and the :error_code for the status code of {:error, response()} results. When response headers are returned, they are expected to be in the form of a map, as this is the format in which the function will receive request headers. They will be converted to [{String.t(), String.t()}] before handing back to the webserver to return to the client. If no response headers are returned, Maverick will automatically add the {&quot;Content-Type&quot;, &quot;application/json&quot;} header. Exceptions In the event an exception is raised during handling of a request, the Handler functions will automatically rescue and construct a response by calling functions from the the Maverick.Exception protocol on the exception. See the exception protocol module for implementing it for specific exceptions.","ref":"Maverick.html","title":"Maverick","type":"module"},{"doc":"","ref":"Maverick.html#handle_response/2","title":"Maverick.handle_response/2","type":"function"},{"doc":"","ref":"Maverick.html#t:api/0","title":"Maverick.api/0","type":"type"},{"doc":"","ref":"Maverick.html#t:otp_app/0","title":"Maverick.otp_app/0","type":"type"},{"doc":"","ref":"Maverick.html#t:root_scope/0","title":"Maverick.root_scope/0","type":"type"},{"doc":"Provides the entrypoint for configuring and managing the implementation of Maverick in an application by a single use/2 macro that provides a supervision tree start_link/1 and child_spec/1 for adding Maverick as a child of the top-level application supervisor. The Api module implementing use Maverick.Api , when started, will orchestrate the start of the process that does the heavy lifting of compiling function routes into a callback Handler module at application boot and then handing off to the Elli webserver configured to route requests by way of that Handler module. use Maverick.Api options :otp_app - The name of the application implementing Maverick as an atom (required). Maverick.Api child_spec and start_link options :init_name - The name the Initializer should register as. Primarily for logging and debugging, as the process should exit immediately with a :normal status if successful. May be any valid GenServer name. :supervisor_name - The name the Maverick supervisor process should register as. May be any valid GenServer name. :name - The name the Elli server process should register as. May be any valid GenServer name. :port - The port number the webserver will listen on. Defaults to 4000. :tls_certfile - The path to the PEM-encoded SSL/TLS certificate file to encrypt requests and responses. :tls_keyfile - The path to the PEM-encoded SSL/TLS key file to encrypt requests and responses.","ref":"Maverick.Api.html","title":"Maverick.Api","type":"module"},{"doc":"","ref":"Maverick.Exception.html","title":"Maverick.Exception","type":"protocol"},{"doc":"","ref":"Maverick.Exception.html#error_code/1","title":"Maverick.Exception.error_code/1","type":"function"},{"doc":"","ref":"Maverick.Exception.html#handle/2","title":"Maverick.Exception.handle/2","type":"function"},{"doc":"","ref":"Maverick.Exception.html#message/1","title":"Maverick.Exception.message/1","type":"function"},{"doc":"","ref":"Maverick.Exception.html#t:t/0","title":"Maverick.Exception.t/0","type":"type"},{"doc":"","ref":"Maverick.Exception.Default.html","title":"Maverick.Exception.Default","type":"module"},{"doc":"Provides functionality for parsing paths to lists of path nodes, identifying path variables for pattern matching on incoming requests.","ref":"Maverick.Path.html","title":"Maverick.Path","type":"module"},{"doc":"Parse a path string to a list of path nodes. A path node is either a String.t() or a tuple of {:variable, String.t()} . Nodes beginning with a colon character (&quot;:&quot;) will parse to a variable tuple. At runtime, variable tuples are used to construct the path params portion of a Maverick request.","ref":"Maverick.Path.html#parse/1","title":"Maverick.Path.parse/1","type":"function"},{"doc":"Reads a path string and validates as a Maverick-compatible path, including any colon (&quot;:&quot;) characters signifying a path variable. Strips any extraneous forward slashes from the result.","ref":"Maverick.Path.html#validate/1","title":"Maverick.Path.validate/1","type":"function"},{"doc":"","ref":"Maverick.Path.html#t:path/0","title":"Maverick.Path.path/0","type":"type"},{"doc":"","ref":"Maverick.Path.html#t:path_node/0","title":"Maverick.Path.path_node/0","type":"type"},{"doc":"","ref":"Maverick.Path.html#t:raw_path/0","title":"Maverick.Path.raw_path/0","type":"type"},{"doc":"","ref":"Maverick.Response.html","title":"Maverick.Response","type":"protocol"},{"doc":"","ref":"Maverick.Response.html#handle/2","title":"Maverick.Response.handle/2","type":"function"},{"doc":"","ref":"Maverick.Response.html#t:t/0","title":"Maverick.Response.t/0","type":"type"},{"doc":"A struct detailing a Maverick Route. The contents are determined at compile time by the annotations applied to routable functions. Maverick uses the routes to construct request handlers for each routable function at runtime.","ref":"Maverick.Route.html","title":"Maverick.Route","type":"module"},{"doc":"Takes an OTP app name and a root scope and returns a list of all routes the app defines as % MODULE structs.","ref":"Maverick.Route.html#list_routes/2","title":"Maverick.Route.list_routes/2","type":"function"},{"doc":"","ref":"Maverick.Route.html#t:args/0","title":"Maverick.Route.args/0","type":"type"},{"doc":"","ref":"Maverick.Route.html#t:error_code/0","title":"Maverick.Route.error_code/0","type":"type"},{"doc":"","ref":"Maverick.Route.html#t:method/0","title":"Maverick.Route.method/0","type":"type"},{"doc":"","ref":"Maverick.Route.html#t:success_code/0","title":"Maverick.Route.success_code/0","type":"type"},{"doc":"","ref":"Maverick.Route.html#t:t/0","title":"Maverick.Route.t/0","type":"type"},{"doc":"Prints all routes for the default or a given Maverick Api #&gt; mix mvk.routes #&gt; mix mvk.routes MyApp.Alternative.Api The default router is drawn from the root name of the application (the :app key in your Mixfile) converted to Elixir &quot;Module-case&quot; and concatenated with .Api similar to the Ecto Repo convention of MyApp.Repo being used to name the module implementing Ecto.Repo .","ref":"Mix.Tasks.Mvk.Routes.html","title":"Mix.Tasks.Mvk.Routes","type":"task"},{"doc":"The path could not be parsed due to illegal character(s)","ref":"Maverick.Path.ParseError.html","title":"Maverick.Path.ParseError","type":"exception"}]